xref: /freebsd/usr.sbin/bsdinstall/scripts/jail (revision 19261079)
1#!/bin/sh
2#-
3# Copyright (c) 2011 Nathan Whitehorn
4# Copyright (c) 2013-2015 Devin Teske
5# All rights reserved.
6#
7# Redistribution and use in source and binary forms, with or without
8# modification, are permitted provided that the following conditions
9# are met:
10# 1. Redistributions of source code must retain the above copyright
11#    notice, this list of conditions and the following disclaimer.
12# 2. Redistributions in binary form must reproduce the above copyright
13#    notice, this list of conditions and the following disclaimer in the
14#    documentation and/or other materials provided with the distribution.
15#
16# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
17# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
18# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
19# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
20# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
21# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
22# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
23# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
24# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
25# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
26# SUCH DAMAGE.
27#
28# $FreeBSD$
29#
30############################################################ INCLUDES
31
32BSDCFG_SHARE="/usr/share/bsdconfig"
33. $BSDCFG_SHARE/common.subr || exit 1
34
35############################################################ MAIN
36
37f_dprintf "Began Installation at %s" "$( date )"
38export BSDINSTALL_CHROOT=$1
39
40error() {
41	local msg
42	if [ -n "$1" ]; then
43		msg="$1\n\n"
44	fi
45	dialog --backtitle "FreeBSD Installer" --title "Abort" \
46	    --no-label "Exit" --yes-label "Restart" --yesno \
47	    "${msg}An installation step has been aborted. Would you like to restart the installation or exit the installer?" 0 0
48	if [ $? -ne 0 ]; then
49		exit
50	else
51		exec $0 $BSDINSTALL_CHROOT
52	fi
53}
54
55rm -rf $BSDINSTALL_TMPETC
56mkdir $BSDINSTALL_TMPETC
57mkdir -p $1 || error "mkdir failed for $1"
58
59if [ -n "$SCRIPT" ]
60then
61        split -a 2 -p '^#!.*' "$SCRIPT" $TMPDIR/bsdinstall-installscript-
62        . $TMPDIR/bsdinstall-installscript-aa
63fi
64
65test ! -d $BSDINSTALL_DISTDIR && mkdir -p $BSDINSTALL_DISTDIR
66
67if [ ! -f $BSDINSTALL_DISTDIR/MANIFEST -a -z "$BSDINSTALL_DISTSITE" ]; then
68	exec 3>&1
69	BSDINSTALL_DISTSITE=$(`dirname $0`/mirrorselect 2>&1 1>&3)
70	MIRROR_BUTTON=$?
71	exec 3>&-
72	test $MIRROR_BUTTON -eq 0 || error "No mirror selected"
73	export BSDINSTALL_DISTSITE
74	fetch -o $BSDINSTALL_DISTDIR/MANIFEST $BSDINSTALL_DISTSITE/MANIFEST || error "Could not download $BSDINSTALL_DISTSITE/MANIFEST"
75fi
76
77: ${DISTRIBUTIONS="base.txz"}; export DISTRIBUTIONS
78if [ -f $BSDINSTALL_DISTDIR/MANIFEST ]; then
79	DISTMENU=`cut -f 4,5,6 $BSDINSTALL_DISTDIR/MANIFEST | grep -v -e ^kernel -e ^base`
80
81    if [ ! "$nonInteractive" == "YES" ]
82    then
83	    exec 3>&1
84	    EXTRA_DISTS=$(echo $DISTMENU | xargs dialog \
85	        --backtitle "FreeBSD Installer" \
86	        --title "Distribution Select" --nocancel --separate-output \
87	        --checklist "Choose optional system components to install:" \
88	        0 0 0 \
89	    2>&1 1>&3)
90	    for dist in $EXTRA_DISTS; do
91	    	export DISTRIBUTIONS="$DISTRIBUTIONS $dist.txz"
92	    done
93    fi
94fi
95
96FETCH_DISTRIBUTIONS=""
97for dist in $DISTRIBUTIONS; do
98	if [ ! -f $BSDINSTALL_DISTDIR/$dist ]; then
99		FETCH_DISTRIBUTIONS="$FETCH_DISTRIBUTIONS $dist"
100	fi
101done
102FETCH_DISTRIBUTIONS=`echo $FETCH_DISTRIBUTIONS`	# Trim white space
103
104if [ -n "$FETCH_DISTRIBUTIONS" -a -z "$BSDINSTALL_DISTSITE" ]; then
105	exec 3>&1
106	BSDINSTALL_DISTSITE=`bsdinstall mirrorselect 2>&1 1>&3`
107	MIRROR_BUTTON=$?
108	exec 3>&-
109	test $MIRROR_BUTTON -eq 0 || error "No mirror selected"
110	export BSDINSTALL_DISTSITE
111fi
112
113if [ ! -z "$FETCH_DISTRIBUTIONS" ]; then
114	bsdinstall distfetch || error "Failed to fetch distribution"
115fi
116
117bsdinstall checksum || error "Distribution checksum failed"
118bsdinstall distextract || error "Distribution extract failed"
119
120if [ ! "$nonInteractive" == "YES" ]
121then
122    bsdinstall rootpass || error "Could not set root password"
123fi
124
125trap true SIGINT	# This section is optional
126
127if [ ! "$nonInteractive" == "YES" ]
128then
129bsdinstall services
130
131    dialog --backtitle "FreeBSD Installer" --title "Add User Accounts" --yesno \
132        "Would you like to add users to the installed system now?" 0 0 && \
133        bsdinstall adduser
134fi
135
136trap error SIGINT	# SIGINT is bad again
137bsdinstall config  || error "Failed to save config"
138cp /etc/resolv.conf $1/etc
139cp /etc/localtime $1/etc
140cp /var/db/zoneinfo $1/var/db
141
142# Run post-install script
143if [ -f $TMPDIR/bsdinstall-installscript-ab ]; then
144	cp $TMPDIR/bsdinstall-installscript-ab $BSDINSTALL_CHROOT/tmp/installscript
145	chmod a+x $BSDINSTALL_CHROOT/tmp/installscript
146	mount -t devfs devfs "$BSDINSTALL_CHROOT/dev"
147	chroot $BSDINSTALL_CHROOT /tmp/installscript $@ 2>&1
148	umount "$BSDINSTALL_CHROOT/dev"
149	rm $BSDINSTALL_CHROOT/tmp/installscript
150fi
151
152bsdinstall entropy
153
154f_dprintf "Installation Completed at %s" "$(date)"
155exit $SUCCESS
156
157################################################################################
158# END
159################################################################################
160